summaryrefslogtreecommitdiffstats
path: root/libraries/protozero
diff options
context:
space:
mode:
author Michales Michaloudes <korgie@gmail.com>2024-02-13 10:05:00 +0700
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2024-02-13 12:36:11 +0700
commit52a58041526a1b6091d11ac7b37358dab0ef1779 (patch)
tree8966166c70a0b2f45813b43aa23856ca8b742d76 /libraries/protozero
parentad4fc30ab5f28bbb6027d47afda5920aed6a635a (diff)
downloadslackbuilds-52a58041526a1b6091d11ac7b37358dab0ef1779.tar.gz
slackbuilds-52a58041526a1b6091d11ac7b37358dab0ef1779.tar.xz
libraries/protozero: Added (protocol buffer decoder and encoder).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'libraries/protozero')
-rw-r--r--libraries/protozero/README10
-rw-r--r--libraries/protozero/protozero.SlackBuild113
-rw-r--r--libraries/protozero/protozero.info10
-rw-r--r--libraries/protozero/slack-desc19
4 files changed, 152 insertions, 0 deletions
diff --git a/libraries/protozero/README b/libraries/protozero/README
new file mode 100644
index 0000000000..1a383f3606
--- /dev/null
+++ b/libraries/protozero/README
@@ -0,0 +1,10 @@
+Minimalistic protocol buffer decoder and encoder in C++.
+
+Designed for high performance. Suitable for writing zero copy parsers
+and encoders with minimal need for run-time allocation of memory.
+
+Low-level: this is designed to be a building block for writing a very
+customized decoder for a stable protobuf schema. If your protobuf
+schema is changing frequently or lazy decoding is not critical for
+your application then this approach offers no value: just use the C++
+API that can be generated with the Google Protobufs protoc program.
diff --git a/libraries/protozero/protozero.SlackBuild b/libraries/protozero/protozero.SlackBuild
new file mode 100644
index 0000000000..bc1c6e32bd
--- /dev/null
+++ b/libraries/protozero/protozero.SlackBuild
@@ -0,0 +1,113 @@
+#!/bin/bash
+
+# Slackware build script for <protozero>
+
+# Copyright 2024, Michales Michaloudes (clavisound), Greece
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=protozero
+VERSION=${VERSION:-1.7.1}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+TMP=${TMP:-/tmp/SBo}
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+elif [ "$ARCH" = "aarch64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+mkdir build
+cd build
+cmake ../
+
+make install DESTDIR=$PKG
+
+mkdir -p $PKG/usr/bin
+cp $TMP/$PRGNAM-$VERSION/build/tools/pbf-decoder $PKG/usr/bin/
+
+# -DCMAKE_INSTALL_INCLUDEDIR=/usr/include not used by the project
+mv $PKG/usr/local/include $PKG/usr/
+rm -r $PKG/usr/local
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION/
+cp -pR $TMP/$PRGNAM-$VERSION/build/doc/html $PKG/usr/doc/$PRGNAM-$VERSION
+cp -pR $TMP/$PRGNAM-$VERSION/doc/*.md $PKG/usr/doc/$PRGNAM-$VERSION
+
+rm -f $PKG/{,usr/}lib${LIBDIRSUFFIX}/*.la
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+cd $TMP/$PRGNAM-$VERSION
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ UPGRADING.md FUZZING.md CHANGELOG.md CONTRIBUTING.md LICENSE* README.md \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/libraries/protozero/protozero.info b/libraries/protozero/protozero.info
new file mode 100644
index 0000000000..dee2d23e0c
--- /dev/null
+++ b/libraries/protozero/protozero.info
@@ -0,0 +1,10 @@
+PRGNAM="protozero"
+VERSION="1.7.1"
+HOMEPAGE="https://github.com/mapbox/protozero"
+DOWNLOAD="https://github.com/mapbox/protozero/archive/v1.7.1/protozero-1.7.1.tar.gz"
+MD5SUM="dafc2d8082e9422560f138a25e74800f"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="Michales Michaloudes"
+EMAIL="korgie@gmail.com"
diff --git a/libraries/protozero/slack-desc b/libraries/protozero/slack-desc
new file mode 100644
index 0000000000..5286673b76
--- /dev/null
+++ b/libraries/protozero/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+protozero: protozero (Minimalistic protocol buffer decoder and encoder in C++.)
+protozero: Designed for high performance. Suitable for writing zero copy parsers
+protozero: and encoders with minimal need for run-time allocation of memory.
+protozero: Low-level: this is designed to be a building block for writing a very
+protozero: customized decoder for a stable protobuf schema. If your protobuf
+protozero: schema is changing frequently or lazy decoding is not critical for
+protozero: your application then this approach offers no value: just use the C++
+protozero: API that can be generated with the Google Protobufs protoc program.
+protozero:
+protozero:
+protozero: